VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4320
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5670
   LinkTopic       =   "Form1"
   ScaleHeight     =   4320
   ScaleWidth      =   5670
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox List2 
      Height          =   2790
      Left            =   2880
      TabIndex        =   2
      Top             =   240
      Width           =   2415
   End
   Begin VB.ListBox lboSort 
      Height          =   2790
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   240
      Width           =   2295
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Sort"
      Height          =   615
      Left            =   1680
      TabIndex        =   0
      Top             =   3360
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Enum SortType
    sString = 1
    dDate = 2
    nNumeric = 3
End Enum
Enum SortDirection
    Ascending = 1
    Descending = 2
End Enum

Private Sub Command1_Click()

    Dim Vals() As String
    Dim i As Long
    
    'Pick 5000 numbers between 1 and 30000
    ReDim Vals(5000)
    For i = 0 To 5000
        Vals(i) = Int((30000 * Rnd) + 1)
    Next i

    Call Sort(Vals, Ascending, nNumeric)

    For i = 0 To UBound(Vals)
        List2.AddItem Vals(i)
    Next i

End Sub

Public Function Sort(Vals() As String, Direction As SortDirection, Style As SortType)
    Dim i As Long
    Dim s As String
    Dim j As Integer
    Dim Vals2() As String
    Dim Count As Long
    
    lboSort.Clear
    Count = UBound(Vals)
    ReDim Vals2(Count)
    
    For i = 0 To Count
        s = Vals(i)
        
        If Style = dDate Then
            s = Format(s, "yyyy/mm/dd hh:mm AM/PM")
        End If
        j = Len(s)
    
        s = Replace(s, "0", "a")
        s = Replace(s, "1", "b")
        s = Replace(s, "2", "c")
        s = Replace(s, "3", "d")
        s = Replace(s, "4", "e")
        s = Replace(s, "5", "f")
        s = Replace(s, "6", "g")
        s = Replace(s, "7", "h")
        s = Replace(s, "8", "i")
        s = Replace(s, "9", "j")
    
        lboSort.AddItem Chr(97 + j) & s
    
    Next i
    
    For i = 0 To lboSort.ListCount - 1
        s = lboSort.List(i)
        
        s = Right(s, Len(s) - 1)
        
        s = Replace(s, "a", "0")
        s = Replace(s, "b", "1")
        s = Replace(s, "c", "2")
        s = Replace(s, "d", "3")
        s = Replace(s, "e", "4")
        s = Replace(s, "f", "5")
        s = Replace(s, "g", "6")
        s = Replace(s, "h", "7")
        s = Replace(s, "i", "8")
        s = Replace(s, "j", "9")
        
        If Style = dDate Then
            s = Format(s, "mm/dd/yyyy hh:mm AM/PM")
        End If
        Vals2(i) = s
    Next i

    If Direction = Descending Then
        'Reverse the elements in the array
        For i = Count To 0 Step -1
            Vals(Count - i) = Vals2(i)
        Next i
    Else
        For i = 0 To Count
            Vals(i) = Vals2(i)
        Next i
        
    End If

End Function
